#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <string.h>

#define _size_mem	32
#define _master_count	0
#define _slave_count	4

int main(int argc, char *argv[]) {
        key_t key;
        int semid, shmid;
        struct sembuf sops;
        char *shmaddr;
        char data[_size_mem] = {0};	//обнуляем массив
	u_int16_t	mster_count;
 
        key=12345;
 
        if ((shmid = shmget(key, _size_mem, IPC_CREAT | 0666)) < 0) { perror("shmget"); return 1; }
        if ((shmaddr = (char*)shmat(shmid, NULL, 0)) == (void*)-1) { perror("shmat"); return 1; }
 
        semid = semget(key, 1, IPC_CREAT | 0666);
        semctl(semid, 0, IPC_SET, 0);
        sops.sem_num = 0;
        sops.sem_flg = 0;
	//начальное копирование данных в общую память
	memcpy(shmaddr, &data[0], _size_mem);
	// Освобождаем доступ
        sops.sem_op = 1; 
        semop(semid, &sops, 1);
        usleep(1000);
 	//
        do {
		// Ожидаем доступа к общей памяти
		sops.sem_op = -1;
                semop(semid, &sops, 1);
		printf("Master Count %.4X   Slave Count %.4X\n", (u_int16_t)*(shmaddr + _master_count), (u_int16_t)(*(shmaddr + _slave_count)));
                if((*(shmaddr + _master_count)) < 0xFFFF)
			(*(shmaddr + _master_count))++;
		else
			(*(shmaddr + _master_count)) = 0;
                // Освобождаем доступ
                sops.sem_op = 1; 
                semop(semid, &sops, 1);
                usleep(1000);
        } while (1);
        shmdt(shmaddr); 
        semctl(semid,0,IPC_RMID, 0); 
        shmctl(shmid,IPC_RMID,NULL); 
 
        return 0;
}

